<template>
  <div>
    <v-row>
      <v-col :cols="12" :sm="12" :md="12" :lg="6" :xl="6">
        <div id="pieChart" class="charts" ref="pieChart"></div>
      </v-col>
      <v-col :cols="12" :sm="12" :md="12" :lg="6" :xl="6">
        <div class="charts" ref="chartdiv2"></div>
        <div id="legend"></div>
      </v-col>
    </v-row>

    <div class="btnCenter">
      <v-btn @click="exportChart" outlined depressed color="secundary"
        >Guardar la gráfica de la información consultada</v-btn
      >
    </div>
  </div>
</template>
<style scoped>
.charts {
  height: 500px;
}
</style>
<script>
import htmlToImage from "html-to-image";
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
import am4themes_material from "@amcharts/amcharts4/themes/material";
import imageFile from "@/assets/img/puntoContacto.svg";
let image;

async function getDataUri(url) {
  var image = new Image();
  image.src = url;
  let data = await new Promise((resolve) => {
    image.onload = function() {
      var canvas = document.createElement("canvas");
      canvas.width = this.naturalWidth; // or 'width' if you want a special/scaled size
      canvas.height = this.naturalHeight; // or 'height' if you want a special/scaled size
      canvas.getContext("2d").drawImage(this, 0, 0);
      let data = canvas.toDataURL();
      resolve(data);
    };
  });
  return data;
}

function am4themes_myTheme(target) {
  if (target instanceof am4core.ColorSet) {
    target.list = [
      am4core.color("#1BA68D"),
      am4core.color("#E7DA4F"),
      am4core.color("#E77624"),
      am4core.color("#DF3520"),
      am4core.color("#64297B"),
      am4core.color("#232555")
    ];
  }
}
//am4core.useTheme(am4themes_animated);
am4core.useTheme(am4themes_myTheme);

export default {
  name: "Component-Region",
  data() {
    return {
      chart: {},
      chart2: {},
      franquicias: [
        {
          descripcion: "Sucursal",
          total: 44,
          territorios: [
            {
              descripcion: "Norte",
              total: 100
            },
            {
              descripcion: "Centro",
              total: 55
            },
            {
              descripcion: "Sur",
              total: 41
            }
          ]
        },
        {
          descripcion: "Banco",
          total: 55,
          territorios: [
            {
              descripcion: "Norte",
              total: 13
            },
            {
              descripcion: "Centro",
              total: 23
            },
            {
              descripcion: "Sur",
              total: 20
            }
          ]
        },
        {
          descripcion: "Tienda I",
          total: 41,
          territorios: [
            {
              descripcion: "Norte",
              total: 11
            },
            {
              descripcion: "Centro",
              total: 17
            },
            {
              descripcion: "Sur",
              total: 15
            }
          ]
        },
        {
          descripcion: "Tienda II",
          total: 47,
          territorios: [
            {
              descripcion: "Norte",
              total: 70
            },
            {
              descripcion: "Centro",
              total: 55
            },
            {
              descripcion: "Sur",
              total: 41
            }
          ]
        }
      ]
    };
  },
  methods: {
    temp() {
      let loadFont = function(svg) {
        const request = new XMLHttpRequest();
        request.open(
          "get",
          "https://fonts.googleapis.com/css?family=Roboto:400,400i,700,700i"
        );
        request.responseType = "text";
        request.send();
        request.onloadend = () => {
          //(2)find all font urls.
          let css = request.response;
          const fontURLs = css.match(/https?:\/\/[^)]+/g);
          let loaded = 0;
          fontURLs.forEach((url) => {
            //(3)get each font binary.
            const request = new XMLHttpRequest();
            request.open("get", url);
            request.responseType = "blob";
            request.onloadend = () => {
              //(4)conver font blob to binary string.
              const reader = new FileReader();
              reader.onloadend = () => {
                //console.log(css)
                //(5)replace font url by binary string.
                css = css.replace(new RegExp(url), reader.result);
                loaded++;
                //check all fonts are replaced.
                if (loaded == fontURLs.length) {
                  let style = document.createElement("style");
                  let defs = svg.getElementsByTagName("defs")[0];
                  style.type = "text/css";
                  if (style.styleSheet) {
                    // This is required for IE8 and below.
                    style.styleSheet.cssText = css;
                  } else {
                    style.appendChild(document.createTextNode(css));
                  }
                  defs.appendChild(style);
                  svg.style.fontFamily = "Roboto";
                }
              };
              reader.readAsDataURL(request.response);
            };
            request.send();
          });
        };
      };

      var svg = document.getElementById("pieChart").childNodes[1].childNodes[0];
      loadFont(svg);
    },
    async exportChart() {
      var svg = document
        .getElementById("pieChart")
        .childNodes[1].getElementsByTagName("svg")[0];

      htmlToImage
        .toSvgDataURL(svg)
        .then(function(dataUrl) {
          var img = new Image();
          img.src = dataUrl;
          document.body.appendChild(img);
        })
        .catch(function(error) {
          console.error("oops, something went wrong!", error);
        });
    }
  },
  mounted() {
    am4core.options.autoSetClassName = true;
    const config = {
      exporting: {
        filePrefix: "Franquicias nivel Nacional"
      },
      data: this.franquicias,
      innerRadius: am4core.percent(60),

      legend: {
        width: 320,
        labels: {
          minWidth: 100,
          text:
            "[font-size: 26px;font-weight: bolder;]{value.percent.formatNumber('#.0')}% · {value}[/] \n [font-size: 20px;font-weight: bolder;]{descripcion}[/]"
        },
        itemContainers: {
          clickable: false,
          focusable: false
        },
        valueLabels: {
          disabled: true,
          minWidth: 100,
          fill: "#f00",
          text: ""
        },
        markers: {
          width: 80,
          height: 60,
          disabled: false,
          children: [
            {
              cornerRadiusTopLeft: 0,
              cornerRadiusTopRight: 0,
              cornerRadiusBottomRight: 0,
              cornerRadiusBottomLeft: 0,
              strokeWidth: 1,
              strokeOpacity: 1,
              stroke: "red"
            }
          ]
        },
        properties: {
          contentAlign: "left",
          position: "right",
          alwaysShowTooltip: true
        }
      },
      logo: {
        properties: {
          hidden: true
        }
      },
      series: [
        {
          children: [
            {
              type: "Label",
              text:
                "Franquicias distribuidas\n a [font-size: 20px;font-weight: bolder;]nivel Nacional {values.value.sum}*[/]",
              forceCreate: true,
              html:
                "<div>Franquicias distribuidas</div><div style='text-align: center'>a <strong>nivel Nacional {values.value.sum}*</strong></div>",
              horizontalCenter: "middle",
              verticalCenter: "middle",
              fontSize: 20
            }
          ],
          calculatePercent: true,
          type: "PieSeries",
          dataFields: {
            value: "total",
            category: "descripcion"
          },
          labels: {
            text: "{value.percent.formatNumber('#.0')}%",
            radius: "-10%",
            fill: "white"
          },
          alignLabels: false,
          ticks: {
            disabled: true
          },
          slices: {
            events: {
              hit: function(ev) {
                var series = ev.target.dataItem.component;
                series.slices.each(function(item) {
                  if (item.isActive && item != ev.target) {
                    item.isActive = false;
                  }
                });
              }
            },
            stroke: am4core.color("white"),
            strokeWidth: 1,
            strokeOpacity: 1,
            states: {
              hover: {
                properties: {
                  scale: 1
                }
              }
            }
          }
        }
      ]
    };
    let drawChart = (imgBase64) => {
      let chart = am4core.createFromConfig(
        config,
        this.$refs.pieChart,
        am4charts.PieChart
      );
      chart.legend.useDefaultMarker = true;
      let markerTemplate = chart.legend.markers.template;
      const img = markerTemplate.createChild(am4core.Image);
      img.width = 40;
      img.height = 40;
      img.align = "center";
      img.dy = 10;
      img.dx = 2;
      img.verticalCenter = "top";
      img.href = imgBase64;
      const activeState = img.states.create("active");
      activeState.properties.opacity = 0;
      this.chart = chart;
      this.temp();
    };
    (async function() {
      let data = await getDataUri(imageFile);
      drawChart(data);
    })();
  },
  beforeDestroy() {
    if (this.chart) {
      this.chart.dispose();
    }
  }
};
</script>
